-- Asklepieion
-- Author: Mathetesalexandrou
-- DateCreated: 10/21/2016 9:16:57 PM
--------------------------------------------------------------
local iAsklepieion = GameInfoTypes["BUILDING_MATHALX_ASKLEPIEION_EN_TEI_KOI"]
local iAsklepieionSinglePolicy = GameInfoTypes["POLICY_MATHALX_ASKLEPIEION_SINGLE"]
local iAsklepieionDoublePolicy = GameInfoTypes["POLICY_MATHALX_ASKLEPIEION_DOUBLE"]
local iAsklepieionDummy = GameInfoTypes["BUILDING_MATHALX_ASKLEPIEION_EN_TEI_KOI_DUMMY"]

local GPCheck = {}

local speedMod = (GameInfo.GameSpeeds[Game.GetGameSpeedType()].BuildPercent)/100

--Credits to Chrisy15
function C15_TextOnPlot(iX, iY, sString) -- Code's basically Suk's fwiw 
    local pHexPos = ToHexFromGrid{x=iX, y=iY}
    local pWorldPos = HexToWorld(pHexPos)
    Events.AddPopupTextEvent(pWorldPos, sString)
end

function checkAsklepieion(playerID, klerosX, klerosY, improvementID)
	local kleros = Map.GetPlot(klerosX, klerosY)
	local improvementID = kleros:GetImprovementType()
	local Owner = kleros:GetOwner()
	local agonistes = Players[Owner]
	local asklepieiones = 0
	local pTeam = Teams[agonistes:GetTeam()]
	if agonistes:IsAlive() then
		for asty in agonistes:Cities() do
			asklepieiones = asklepieiones + asty:GetNumBuilding(iAsklepieion)
		end
		if improvementID == GameInfoTypes["IMPROVEMENT_HOLY_SITE"] then
			if kleros:GetYield(YieldTypes.YIELD_FOOD) ~= (kleros:CalculateNatureYield(YieldTypes.YIELD_FOOD, pTeam, false) + kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_FOOD, agonistes) + 2*asklepieiones) then
				--First time Holy site enters, so no calculations
				Game.SetPlotExtraYield(klerosX, klerosY, GameInfoTypes.YIELD_FOOD, 2*asklepieiones)
			end
			if kleros:GetYield(YieldTypes.YIELD_SCIENCE) ~= (kleros:CalculateNatureYield(YieldTypes.YIELD_SCIENCE, pTeam, false) + kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_SCIENCE, agonistes) + 2*asklepieiones) then
				Game.SetPlotExtraYield(klerosX, klerosY, GameInfoTypes.YIELD_SCIENCE, 2*asklepieiones)
			end
		end
	end
end
--GameEvents.BuildFinished.Add(checkAsklepieion)
 
function checkAsklepieionTurn(playerID)
	local agonistes = Players[playerID]
	local pTeam = Teams[agonistes:GetTeam()]
	if agonistes:IsAlive() then
		local asklepieiones = 0
		for asty in agonistes:Cities() do
			asklepieiones = asklepieiones + asty:GetNumBuilding(iAsklepieion)
		end   
		for asty in agonistes:Cities() do
			for cityPlot = 0, asty:GetNumCityPlots() - 1, 1 do
				local kleros = asty:GetCityIndexPlot(cityPlot)
				if kleros:GetOwner() == asty:GetOwner() and kleros:GetPlotCity() == nil then
					if ((kleros:GetImprovementType() ~= GameInfoTypes["IMPROVEMENT_HOLY_SITE"]) or (kleros:GetImprovementType() == GameInfoTypes["IMPROVEMENT_HOLY_SITE"] and kleros:IsImprovementPillaged())) then
						--Simple reset: what needs calculating is current yield (includes the wonder yield) - base yield from tile and improvement
						local diffFood = kleros:GetYield(YieldTypes.YIELD_FOOD) - kleros:CalculateNatureYield(YieldTypes.YIELD_FOOD, pTeam, false) - kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_FOOD, agonistes)
						--print("No Holy site. Current Yield: " ..kleros:GetYield(YieldTypes.YIELD_FOOD) ..", Natural Yield: " .. kleros:CalculateNatureYield(YieldTypes.YIELD_FOOD, pTeam, false) .. ", Improvement Yield: " ..kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_FOOD, agonistes) .. ", Set Variable: " ..diffFood)
						Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_FOOD, -diffFood)
						--Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_FOOD, 0)
						local diffScience = kleros:GetYield(YieldTypes.YIELD_SCIENCE) - kleros:CalculateNatureYield(YieldTypes.YIELD_SCIENCE, pTeam, false) - kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_SCIENCE, agonistes)
						Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_SCIENCE, -diffScience)
						--Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_SCIENCE, 0)
					else
						--Ought value (natural yields + improvement yield (policy+base+tech) + 2 * number of asklepieion wonder (because Kaguya and IGE)) - current yield
						local diffFood = (2 * asklepieiones) + kleros:CalculateNatureYield(YieldTypes.YIELD_FOOD, pTeam, false) + kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_FOOD, agonistes) - kleros:GetYield(YieldTypes.YIELD_FOOD)
						--print("Has found Holy Site. Current Yield: " ..kleros:GetYield(YieldTypes.YIELD_FOOD) ..", Natural Yield: " .. kleros:CalculateNatureYield(YieldTypes.YIELD_FOOD, pTeam, false) .. ", Improvement Yield: " ..kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_FOOD, agonistes) .. ", Set Variable: " ..diffFood)
						Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_FOOD, diffFood)
						--Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_FOOD, (2 * asklepieiones))
						local diffScience = (2 * asklepieiones) + kleros:CalculateNatureYield(YieldTypes.YIELD_SCIENCE, pTeam, false) + kleros:CalculateImprovementYieldChange(kleros:GetImprovementType(), YieldTypes.YIELD_SCIENCE, agonistes) - kleros:GetYield(YieldTypes.YIELD_SCIENCE)
						Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_SCIENCE, diffScience)
						--Game.SetPlotExtraYield(kleros:GetX(), kleros:GetY(), GameInfoTypes.YIELD_SCIENCE, (2 * asklepieiones))
					end
				end
			end
		end
	end
end
--GameEvents.PlayerDoTurn.Add(checkAsklepieionTurn)

function checkAsklepieionTurnNew(playerID)
	local agonistes = Players[playerID]
	--local pTeam = Teams[agonistes:GetTeam()]
	if agonistes:IsAlive() then
		local asklepieiones = 0
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iAsklepieion) then
				asklepieiones = asklepieiones + 1
			end
		end   
		--Asklepieion plural is asklepieia
		print("YER ASKLEPIEIA: "..asklepieiones)
		if asklepieiones > 0 and not agonistes:HasPolicy(iAsklepieionSinglePolicy) then
			agonistes:SetNumFreePolicies(1)
			agonistes:SetHasPolicy(iAsklepieionSinglePolicy, true)
			agonistes:SetNumFreePolicies(0)
		elseif asklepieiones <= 0 then
			agonistes:SetHasPolicy(iAsklepieionSinglePolicy, false)
		end
		if asklepieiones > 1 and not agonistes:HasPolicy(iAsklepieionDoublePolicy) then
			agonistes:SetNumFreePolicies(1)
			agonistes:SetHasPolicy(iAsklepieionDoublePolicy, true)
			agonistes:SetNumFreePolicies(0)
		elseif asklepieiones <= 1 then
			agonistes:SetHasPolicy(iAsklepieionDoublePolicy, false)
		end
	end
end
GameEvents.PlayerDoTurn.Add(checkAsklepieionTurnNew)

function asklepieionGPGeneration(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local agonistes = Players[playerID]
	local lochos = agonistes:GetUnitByID(unitID)
	if lochos:IsGreatPerson() and not GPCheck[unitID] then
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iAsklepieion) then
				--New Bonus
				local skeuoi = math.ceil(10*(1+agonistes:GetCurrentEra())*speedMod);

				asty:ChangeFood(skeuoi)
				agonistes:ChangeJONSCulture(skeuoi)
				agonistes:ChangeFaith(skeuoi)
				C15_TextOnPlot(asty:GetX(), asty:GetY(), Locale.ConvertTextKey("+{1_Food} [ICON_FOOD]/[ICON_CULTURE]/[ICON_PEACE]", skeuoi))

				--Old bonus
				--asty:SetNumRealBuilding(iAsklepieionDummy, asty:GetNumBuilding(iAsklepieionDummy)+1)
			end
		end
		GPCheck[unitID] = 1
	end
end

Events.SerialEventUnitCreated.Add(asklepieionGPGeneration)