-- BibliothekePergamene
-- Author: Mathetesalexandrou
-- DateCreated: 5/22/2016 3:15:59 AM
--------------------------------------------------------------
local bibliotheke = GameInfoTypes["BUILDING_MATHALX_PERGAMENE_LIBRARY"]
local empeiria = GameInfoTypes["BUILDING_MATHALX_PERGAMENE_LIBRARY_SCIENCE_DUMMY"]


--Credit to Vice Virtuoso's Vocaloid UA
local tGreatWritingBuildings = {};
for pBuilding in GameInfo.Buildings() do
	if pBuilding.GreatWorkSlotType == "GREAT_WORK_SLOT_LITERATURE" and pBuilding.GreatWorkCount > 0 then
		local pBuildingClass = GameInfo.BuildingClasses("Type = '" ..pBuilding.BuildingClass.. "'")()
		--Save BuildingClasses instead of BuildingTypes since GetBuildingGreatWork() calls for Classes
		tGreatWritingBuildings[pBuildingClass.ID] = pBuildingClass.Type
		--dprint("Added buildingclass " ..Locale.ConvertTextKey(pBuildingClass.Description).. " to Great Work building table")
	end
end

function BibliothekePergamenesEmporoi(playerID)
	local agonistes = Players[playerID]
	local tradeRoutes = {};
	local size = 0

	local asteis = {}

	for shanghai = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		jPlayer = Players[shanghai]
		for angID, shimyoung in pairs(jPlayer:GetTradeRoutes()) do
			size = size + 1
			tradeRoutes[size] = shimyoung
		end
		--print("DA TRADE ROUTES: " ..size)
	end
	--print("TOTAL SIZE: " ..size)

	for asty in agonistes:Cities() do
		asteis[asty] = 0
	end

	for tID, emporia in pairs(tradeRoutes) do
		local astyPompe = emporia.FromCity
		local astyLepta = emporia.ToCity

		--print(emporia.FromCity ..", " ..emporia.ToCity)

		if astyPompe:IsHasBuilding(bibliotheke) then
			--astyPompe:SetNumRealBuilding(empeiria, astyPompe:GetNumBuilding(empeiria)+1)
			--Check if city is in list
			for asty in agonistes:Cities() do
				if asty == astyPompe then
					--print("ANG LIB")
					asteis[asty] = asteis[asty] + 1
				end
			end
		end
		if astyLepta:IsHasBuilding(bibliotheke) then
			--astyLepta:SetNumRealBuilding(empeiria, astyLepta:GetNumBuilding(empeiria)+1)
			--Check if city is in list
			for asty in agonistes:Cities() do
				if asty == astyPompe then
					--print("ANG LIB")
					asteis[asty] = asteis[asty] + 1
				end
			end
		end
	end

	for asty in agonistes:Cities() do
		asty:SetNumRealBuilding(empeiria, asteis[asty])
	end
	--print("YER SCIENCE IS " ..yerscience)
	--if yerscience > 0 then
		--Players[Game.GetActivePlayer()]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "DEBUG", yerscience)
	--end
end

GameEvents.PlayerDoTurn.Add(BibliothekePergamenesEmporoi)

function UpdateGreatWorkScience(iPlayer)
	if iPlayer >= GameDefines.MAX_MAJOR_CIVS then return end
	local agonistes = Players[iPlayer]
	if agonistes:IsEverAlive() then
		for asty in agonistes:Cities() do
			local greatWorks = 0
			for iBuildingClass, pBuildingClass in pairs(tGreatWritingBuildings) do
				greatWorks = greatWorks + asty:GetNumGreatWorksInBuilding(iBuildingClass)
			end

			asty:SetNumRealBuilding(empeiria, asty:GetNumBuilding(empeiria)+greatWorks)
		end
	end
end

GameEvents.PlayerDoTurn.Add(UpdateGreatWorkScience)