-- Jiphyeonjun
-- Author: Mathetesalexandrou
-- DateCreated: 5/22/2016 3:15:49 AM
--------------------------------------------------------------
local iScientistDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_SCIENTIST_DUMMY"]
local iEngineerDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_ENGINEER_DUMMY"]
--local iMerchantDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_MERCHANT_DUMMY"]
local iArtistDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_ARTIST_DUMMY"]
local iMusicianDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_MUSICIAN_DUMMY"]
local iWriterDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_WRITER_DUMMY"]

local iScientistCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_SCIENTIST_CULTURE_DUMMY"]
local iEngineerCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_ENGINEER_CULTURE_DUMMY"]
--local iMerchantCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_MERCHANT_CULTURE_DUMMY"]
local iArtistCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_ARTIST_CULTURE_DUMMY"]
local iMusicianCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_MUSICIAN_CULTURE_DUMMY"]
local iWriterCultureDummy = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES_WRITER_CULTURE_DUMMY"]

local iJiphyeonjun = GameInfoTypes["BUILDING_MATHALX_HALL_OF_WORTHIES"]

local GPCheck = {}

local GPList = {}
local GPBList = {}
GPList[1] = GameInfoTypes["UNITCLASS_SCIENTIST"]
GPBList[1] = iScientistDummy
GPList[2] = GameInfoTypes["UNITCLASS_SCIENTIST"]
GPBList[2] = iScientistDummy
GPList[3] = GameInfoTypes["UNITCLASS_ENGINEER"]
GPBList[3] = iEngineerDummy
GPList[4] = GameInfoTypes["UNITCLASS_ENGINEER"]
GPBList[4] = iEngineerDummy
GPList[5] = GameInfoTypes["UNITCLASS_ARTIST"]
GPBList[5] = iArtistDummy
GPList[6] = GameInfoTypes["UNITCLASS_MUSICIAN"]
GPBList[6] = iMusicianDummy
GPList[7] = GameInfoTypes["UNITCLASS_WRITER"]
GPBList[7] = iWriterDummy

function GetRandomJiphyeonjeon(lower, upper)
    return Map.Rand((upper + 1) - lower, "") + lower
end

--math.randomseed(os.time())

function JiphyeonjunGreatPeople(iPlayer)
	local agonistes = Players[iPlayer]
	for asty in agonistes:Cities() do
		if asty:IsHasBuilding(iJiphyeonjun) then
			--print("CITY HAS JIPHYEONJUN")

			if asty:IsHasBuilding(iScientistDummy) then
				--GP point dummy buildings doesn't stack, but stack it anyways for debugging purposes
				--asty:SetNumRealBuilding(iScientistDummy, 1)
				asty:SetNumRealBuilding(iScientistCultureDummy, math.ceil(asty:GetJONSCulturePerTurn()*.12))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_SCIENTIST"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			elseif asty:IsHasBuilding(iEngineerDummy) then
				--asty:SetNumRealBuilding(iEngineerDummy, 1+math.ceil(asty:GetJONSCulturePerTurn()*.1))
				asty:SetNumRealBuilding(iEngineerCultureDummy, math.ceil(asty:GetJONSCulturePerTurn()*.12))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_ENGINEER"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			--elseif asty:IsHasBuilding(iMerchantDummy) then
				--asty:SetNumRealBuilding(iMerchantDummy, 1+math.ceil(asty:GetJONSCulturePerTurn()*.1))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_MERCHANT"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			elseif asty:IsHasBuilding(iArtistDummy) then
				--asty:SetNumRealBuilding(iArtistDummy, 1+math.ceil(asty:GetJONSCulturePerTurn()*.1))
				asty:SetNumRealBuilding(iArtistCultureDummy, math.ceil(asty:GetJONSCulturePerTurn()*.12))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_ARTIST"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			elseif asty:IsHasBuilding(iMusicianDummy) then
				--asty:SetNumRealBuilding(iMusicianDummy, 1+math.ceil(asty:GetJONSCulturePerTurn()*.1))
				asty:SetNumRealBuilding(iMusicianCultureDummy, math.ceil(asty:GetJONSCulturePerTurn()*.12))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_MUSICIAN"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			elseif asty:IsHasBuilding(iWriterDummy) then
				--asty:SetNumRealBuilding(iWriterDummy, 1+math.ceil(asty:GetJONSCulturePerTurn()*.1))
				asty:SetNumRealBuilding(iWriterCultureDummy, math.ceil(asty:GetJONSCulturePerTurn()*.12))
				--asty:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["SPECIALIST_WRITER"], math.ceil(asty:GetJONSCulturePerTurn()*.07)*100)
			else
				randomGPSelect(nil, asty)
			end
		end
	end
end

function switchGP(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local agonistes = Players[playerID]
	local lochos = agonistes:GetUnitByID(unitID)
	if lochos ~= nil then
		if lochos:IsGreatPerson() and not GPCheck[unitID] then
			local asty = nil
			local plot = lochos:GetPlot()

			if plot:IsCity() then
				asty = plot:GetPlotCity()
			end

			if asty == nil then
				local astyplesia = nil
				local diastasis = 4
				for astynea in agonistes:Cities() do
					if Map.PlotDistance(astynea:GetX(), astynea:GetY(), lochos:GetX(), lochos:GetY()) < diastasis then
						diastasis = Map.PlotDistance(astynea:GetX(), astynea:GetY(), lochos:GetX(), lochos:GetY())
						astyplesia = astynea
					end
				end
				asty = astyplesia
			end

			if asty ~= nil and asty:IsHasBuilding(iJiphyeonjun) then
				local goja = 1
				local found = false
				while not found and goja < 8 do
					if lochos:GetUnitClassType() == GPList[goja] and asty:IsHasBuilding(GPBList[goja]) then
						randomGPSelect(GPList[goja], asty)
						found = true
					end
					goja = goja + 1
				end
			end

			GPCheck[unitID] = 1
		end
	end
end

function randomGPSelect(exclude, asty)
	local gojalist = {}
	local size = 0
	
	asty:SetNumRealBuilding(iScientistDummy, 0)
	asty:SetNumRealBuilding(iEngineerDummy, 0)
	--asty:SetNumRealBuilding(iMerchantDummy, 0)
	asty:SetNumRealBuilding(iArtistDummy, 0)
	asty:SetNumRealBuilding(iMusicianDummy, 0)
	asty:SetNumRealBuilding(iWriterDummy, 0)

	asty:SetNumRealBuilding(iScientistCultureDummy, 0)
	asty:SetNumRealBuilding(iEngineerCultureDummy, 0)
	--asty:SetNumRealBuilding(iMerchantDummy, 0)
	asty:SetNumRealBuilding(iArtistCultureDummy, 0)
	asty:SetNumRealBuilding(iMusicianCultureDummy, 0)
	asty:SetNumRealBuilding(iWriterCultureDummy, 0)

	for iGoja = 1, 7, 1 do
		if exclude ~= GPList[iGoja] then
			print("ADD ENTRY: "..GPList[iGoja])
			size = size + 1
			gojalist[size] = GPBList[iGoja]
		else
			print("WTF, " ..exclude ..", " ..GPList[iGoja])
		end
	end

	print(size)
	local ang = GetRandomJiphyeonjeon(1, size)
	print(ang)
	asty:SetNumRealBuilding(gojalist[ang], 1)
end

GameEvents.PlayerDoTurn.Add(JiphyeonjunGreatPeople)
Events.SerialEventUnitCreated.Add(switchGP)