-- MouseionTesAlexandreias
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 9/16/2017 10:03:43 PM
--------------------------------------------------------------
local iMouseion = GameInfoTypes["BUILDING_MATHALX_MOUSEION_TES_ALEXANDREIAS"]
local GPListSpawn = {}
local iScientistClass = GameInfoTypes["UNITCLASS_SCIENTIST"]
local iEngineerClass = GameInfoTypes["UNITCLASS_ENGINEER"]

function spawnGP(playerID, unitID)
	local agonistes = Players[playerID]
	local taxeis = agonistes:GetUnitByID(unitID)
	if GPListSpawn[unitID] == nil then
		if taxeis:GetUnitClassType() == iEngineerClass or taxeis:GetUnitClassType() == iScientistClass then
			local mouseiones = 0

			for asty in agonistes:Cities() do
				if asty:IsHasBuilding(iMouseion) then
					mouseiones = mouseiones + 1
				end
			end

			local iRawDelta = 45 * mouseiones
			local iGPModifier = GameInfo.GameSpeeds[Game.GetGameSpeedType()].GreatPeoplePercent
			local iDelta = math.ceil(iRawDelta * iGPModifier)

			for astyauthis in agonistes:Cities() do
				if taxeis:GetUnitClassType() == iEngineerClass then
					astyauthis:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["UNIT_SCIENTIST"], iDelta)
				else
					astyauthis:ChangeSpecialistGreatPersonProgressTimes100(GameInfoTypes["UNIT_ENGINEER"], iDelta)
				end
			end
		end
		GPListSpawn[unitID] = 1
	end
end

Events.SerialEventUnitCreated.Add(spawnGP)