-- Kynosarges
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 9/16/2017 10:03:33 PM
--------------------------------------------------------------
local iKynosarges = GameInfoTypes["BUILDING_MATHALX_KYNOSARGES"]
local iKynosargesDummy = GameInfoTypes["BUILDING_MATHALX_KYNOSARGES_CYNIC_DUMMY"]

--Core Function
function KynosargesUnhappinessUpdate(iPlayer)
	local agonistes = Players[iPlayer]

	local happiness = agonistes:GetExcessHappiness()
	if happiness < 0 then
		local ang = -happiness
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iKynosarges) then
				if asty:GetNumBuilding(iKynosargesDummy) < ang then
					asty:SetNumRealBuilding(iKynosargesDummy, ang)
				end
			end
		end
	end
end

function poliorkia(iPlayer, isCapital, cityX, cityY, iNewPlayer)
	KynosargesUnhappinessUpdate(iNewPlayer)
end

function ktizeinPolin(iPlayer, cityX, cityY)
	KynosargesUnhappinessUpdate(iPlayer)
end

function KynosargesUpdate(iPlayer)
	KynosargesUnhappinessUpdate(iPlayer)
end

GameEvents.CityCaptureComplete.Add(poliorkia)
GameEvents.PlayerCityFounded.Add(ktizeinPolin)
GameEvents.PlayerDoTurn.Add(KynosargesUpdate)