-- Lykeion
-- Author: Mathetesalexandrou
-- DateCreated: 10/21/2016 9:16:32 PM
--------------------------------------------------------------
include("Sukritact_SaveUtils.lua")
MY_MOD_NAME = "Mathalx_Lykeion";
--------------------------------------------------------------------------------------------------------------------------
-- JFD_GetUniqueUnit by JFD
--------------------------------------------------------------------------------------------------------------------------
local iLykeion = GameInfoTypes["BUILDING_MATHALX_LYKEION_ARISTOTELOU"]

function JFD_GetUniqueUnit(player, unitClass)
  local unitType = nil
  local civType = GameInfo.Civilizations[player:GetCivilizationType()].Type
 
  for uniqueUnit in GameInfo.Civilization_UnitClassOverrides{CivilizationType = civType, UnitClassType = unitClass} do
    unitType = uniqueUnit.UnitType
    break
  end
 
  if (unitType == nil) then
    unitType = GameInfo.UnitClasses[unitClass].DefaultUnit
  end
 
  return unitType
end

function freeScientistLykeion(iPlayer)
	local agonistes = Players[iPlayer]
	local trigger = false
	for asty in agonistes:Cities() do
		print(asty:GetNumBuilding(iLykeion))
		if asty:GetNumBuilding(iLykeion) > 0 then
			if agonistes:HasPolicy(GameInfoTypes["POLICY_TRADITION_FINISHER"]) then
				print(load(agonistes, "Lykeion_Tradition"))
				if not load(agonistes, "Lykeion_Tradition") or load(agonistes, "Lykeion_Tradition") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_LIBERTY_FINISHER"]) then
				print(load(agonistes, "Lykeion_Liberty"))
				if not load(agonistes, "Lykeion_Liberty") or load(agonistes, "Lykeion_Liberty") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_HONOR_FINISHER"]) then
				print(load(agonistes, "Lykeion_Honor"))
				if not load(agonistes, "Lykeion_Honor") or load(agonistes, "Lykeion_Honor") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_PIETY_FINISHER"]) then
				print(load(agonistes, "Lykeion_Piety"))
				if not load(agonistes, "Lykeion_Piety") or load(agonistes, "Lykeion_Piety") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_PATRONAGE_FINISHER"]) then
				print(load(agonistes, "Lykeion_Patronage"))
				if not load(agonistes, "Lykeion_Patronage") or load(agonistes, "Lykeion_Patronage") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_AESTHETICS_FINISHER"]) then
				print(load(agonistes, "Lykeion_Liberty"))
				if not load(agonistes, "Lykeion_Aesthetics") or load(agonistes, "Lykeion_Aesthetics") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_COMMERCE_FINISHER"]) then
				print(load(agonistes, "Lykeion_Commerce"))
				if not load(agonistes, "Lykeion_Commerce") or load(agonistes, "Lykeion_Commerce") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_EXPLORATION_FINISHER"]) then
				print(load(agonistes, "Lykeion_Exploration"))
				if not load(agonistes, "Lykeion_Exploration") or load(agonistes, "Lykeion_Exploration") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
			if agonistes:HasPolicy(GameInfoTypes["POLICY_RATIONALISM_FINISHER"]) then
				print(load(agonistes, "Lykeion_Rationalism"))
				if not load(agonistes, "Lykeion_Rationalism") or load(agonistes, "Lykeion_Rationalism") == nil then
					trigger = true
					agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
				end
			end
		end
	end
	if trigger then
		if agonistes:HasPolicy(GameInfoTypes["POLICY_TRADITION_FINISHER"]) then
			save(agonistes, "Lykeion_Tradition", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_LIBERTY_FINISHER"]) then
			save(agonistes, "Lykeion_Liberty", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_HONOR_FINISHER"]) then
			save(agonistes, "Lykeion_Honor", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_PIETY_FINISHER"]) then
			save(agonistes, "Lykeion_Piety", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_PATRONAGE_FINISHER"]) then
			save(agonistes, "Lykeion_Patronage", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_AESTHETICS_FINISHER"]) then
			save(agonistes, "Lykeion_Aesthetics", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_COMMERCE_FINISHER"]) then
			save(agonistes, "Lykeion_Commerce", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_EXPLORATION_FINISHER"]) then
			save(agonistes, "Lykeion_Exploration", true)
		end
		if agonistes:HasPolicy(GameInfoTypes["POLICY_RATIONALISM_FINISHER"]) then
			save(agonistes, "Lykeion_Rationalism", true)
		end
	end
end

GameEvents.PlayerDoTurn.Add(freeScientistLykeion)
GameEvents.PlayerAdoptPolicy.Add(freeScientistLykeion)
