-- NymphaionEnTeiMiezai
-- Author: Mathetesalexandrou
-- DateCreated: 1/30/2017 6:52:07 PM
--------------------------------------------------------------
include("Sukritact_SaveUtils.lua")
MY_MOD_NAME = "Mathalx_Mieza";
local iMod = ((GameInfo.GameSpeeds[Game.GetGameSpeedType()].BuildPercent)/100)
local iMieza = GameInfoTypes["BUILDING_MATHALX_NYMPHAION_EN_TEI_MIEZAI"]
local iMiezaGPDummy = GameInfoTypes["BUILDING_MATHALX_NYMPHAION_EN_TEI_MIEZAI_GP_DUMMY"]

function GetRandomMieza(lower, upper)
	return Map.Rand((upper + 1) - lower, "") + lower
end

function JFD_GetUniqueUnit(player, unitClass)
  local unitType = nil
  local civType = GameInfo.Civilizations[player:GetCivilizationType()].Type
 
  for uniqueUnit in GameInfo.Civilization_UnitClassOverrides{CivilizationType = civType, UnitClassType = unitClass} do
    unitType = uniqueUnit.UnitType
    break
  end
 
  if (unitType == nil) then
    unitType = GameInfo.UnitClasses[unitClass].DefaultUnit
  end
 
  return unitType
end

function miezaFreeGreatPeople(iPlayer)
	local agonistes = Players[iPlayer]
	if agonistes:IsAlive() then
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iMieza) then
				if load(asty:Plot(), "MATHALX_MIEZA_FREE_GPP") ~= nil then
					save(asty:Plot(), "MATHALX_MIEZA_FREE_GPP", load(asty:Plot(), "MATHALX_MIEZA_FREE_GPP") + asty:GetFaithPerTurn())
				else
					save(asty:Plot(), "MATHALX_MIEZA_FREE_GPP", asty:GetFaithPerTurn())
				end

				print("City " .. asty:GetName() .. "'s Mieza Faith = " .. load(asty:Plot(), "MATHALX_MIEZA_FREE_GPP"))

				if load(asty:Plot(), "MATHALX_MIEZA_FREE_GP_NUM") == nil then
					save(asty:Plot(), "MATHALX_MIEZA_FREE_GP_NUM", 0)
				end

				if load(asty:Plot(), "MATHALX_MIEZA_FREE_GPP") >= math.floor(420 * (1+load(asty:Plot(), "MATHALX_MIEZA_FREE_GP_NUM")) * iMod) then
					local ang = GetRandomMieza(1, 3)
					print(ang)
					if ang == 1 then
						agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_SCIENTIST")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
					elseif ang == 2 then
						agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_ENGINEER")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
					else
						agonistes:InitUnit(GameInfoTypes[JFD_GetUniqueUnit(agonistes, "UNITCLASS_GREAT_GENERAL")], asty:GetX(), asty:GetY()):JumpToNearestValidPlot()
					end
					
					save(asty:Plot(), "MATHALX_MIEZA_FREE_GPP", 0)
					save(asty:Plot(), "MATHALX_MIEZA_FREE_GP_NUM", load(asty:Plot(), "MATHALX_MIEZA_FREE_GP_NUM")+1)
				end
			end
		end
	end
end

function miezaGreatPeopleBonusFaith(iPlayer)
	local agonistes = Players[iPlayer]
	if agonistes:IsAlive() then
		for asty in agonistes:Cities() do
			if asty:IsHasBuilding(iMieza) then
				asty:SetNumRealBuilding(iMiezaGPDummy, asty:GetFaithPerTurn())
			end
		end
	end
end

GameEvents.PlayerDoTurn.Add(miezaFreeGreatPeople)
--GameEvents.PlayerDoTurn.Add(miezaFreeGreatPeopleDummy)
GameEvents.PlayerDoTurn.Add(miezaGreatPeopleBonusFaith)